//================================================================================
// MapList.
//
// Copyright(c) 2003, Winged Unicorn.
//================================================================================
class MCoopMapList extends ServerActor
	abstract
	config(MCoopMaps);


struct MapNode
{
	var config string MapName;
	var config int TimeLimit;
};

var(Maps) config MapNode Maps[256];
var config int MapNum;


function string GetNextMap()
{
	local string CurrentMap;
	local int i;

	CurrentMap = getCurrentMap();
	if ( CurrentMap != "" )
	{
		for ( i=0; i<ArrayCount(Maps) && (Maps[i].MapName != ""); i++ )
			if ( CurrentMap ~= Maps[i].MapName )
			{
				MapNum = i;
				break;
			}
	}

	// search vs. w/ or w/out .unr extension
	MapNum++;
	if ( MapNum > ArrayCount(Maps) - 1 )
		MapNum = 0;
	if ( Maps[MapNum].MapName == "" )
		MapNum = 0;

	SaveConfig();

	return Maps[MapNum].MapName;
}

function int GetTimeLimit()
{
	local string CurrentMap;
	local int i;

	CurrentMap = getCurrentMap();
	if ( CurrentMap != "" )
	{
		for ( i=0; i<ArrayCount(Maps) && (Maps[i].MapName != ""); i++ )
			if ( CurrentMap ~= Maps[i].MapName )
				return Maps[i].TimeLimit;
	}

	return 0;
}

function getMapInfo(int Number, out string URL, out int TimeLimit)
{
	URL = Maps[Number].MapName;
	TimeLimit = Maps[Number].TimeLimit;
}

// Original function from WFlexMap
// all credits to }TCP{Wolf
function string getCurrentMap()
{
	local string sb;

	sb = string(Level.Game);
	while (Right(sb, 1) != ".")
	{
		sb = Left(sb, len(sb)-1);
		if (sb == "")
			break;
	}
	sb = Left(sb, Len(sb)-1);

	return sb;
}

defaultproperties
{
}
